import * as cog from '../cog';
import * as xychart from '../xychart';
import * as common from '../common';
export declare class ScatterSeriesConfigBuilder implements cog.Builder<xychart.ScatterSeriesConfig> {
    protected readonly internal: xychart.ScatterSeriesConfig;
    constructor();
    /**
     * Builds the object.
     */
    build(): xychart.ScatterSeriesConfig;
    x(x: string): this;
    y(y: string): this;
    name(name: string): this;
    show(show: xychart.ScatterShow): this;
    pointSize(pointSize: cog.Builder<common.ScaleDimensionConfig>): this;
    pointColor(pointColor: cog.Builder<common.ColorDimensionConfig>): this;
    lineColor(lineColor: cog.Builder<common.ColorDimensionConfig>): this;
    lineWidth(lineWidth: number): this;
    lineStyle(lineStyle: cog.Builder<common.LineStyle>): this;
    label(label: common.VisibilityMode): this;
    hideFrom(hideFrom: cog.Builder<common.HideSeriesConfig>): this;
    axisPlacement(axisPlacement: common.AxisPlacement): this;
    axisColorMode(axisColorMode: common.AxisColorMode): this;
    axisLabel(axisLabel: string): this;
    axisWidth(axisWidth: number): this;
    axisSoftMin(axisSoftMin: number): this;
    axisSoftMax(axisSoftMax: number): this;
    axisGridShow(axisGridShow: boolean): this;
    scaleDistribution(scaleDistribution: cog.Builder<common.ScaleDistributionConfig>): this;
    axisCenteredZero(axisCenteredZero: boolean): this;
    frame(frame: number): this;
    labelValue(labelValue: cog.Builder<common.TextDimensionConfig>): this;
    axisBorderShow(axisBorderShow: boolean): this;
}
