import * as common from '../common';
export declare enum SeriesMapping {
    Auto = "auto",
    Manual = "manual"
}
export declare const defaultSeriesMapping: () => SeriesMapping;
export declare enum ScatterShow {
    Points = "points",
    Lines = "lines",
    PointsAndLines = "points+lines"
}
export declare const defaultScatterShow: () => ScatterShow;
export interface XYDimensionConfig {
    frame: number;
    x?: string;
    exclude?: string[];
}
export declare const defaultXYDimensionConfig: () => XYDimensionConfig;
export interface FieldConfig {
    show?: ScatterShow;
    pointSize?: common.ScaleDimensionConfig;
    pointColor?: common.ColorDimensionConfig;
    lineColor?: common.ColorDimensionConfig;
    lineWidth?: number;
    lineStyle?: common.LineStyle;
    label?: common.VisibilityMode;
    hideFrom?: common.HideSeriesConfig;
    axisPlacement?: common.AxisPlacement;
    axisColorMode?: common.AxisColorMode;
    axisLabel?: string;
    axisWidth?: number;
    axisSoftMin?: number;
    axisSoftMax?: number;
    axisGridShow?: boolean;
    scaleDistribution?: common.ScaleDistributionConfig;
    axisCenteredZero?: boolean;
    labelValue?: common.TextDimensionConfig;
    axisBorderShow?: boolean;
}
export declare const defaultFieldConfig: () => FieldConfig;
export interface ScatterSeriesConfig {
    x?: string;
    y?: string;
    name?: string;
    show?: ScatterShow;
    pointSize?: common.ScaleDimensionConfig;
    pointColor?: common.ColorDimensionConfig;
    lineColor?: common.ColorDimensionConfig;
    lineWidth?: number;
    lineStyle?: common.LineStyle;
    label?: common.VisibilityMode;
    hideFrom?: common.HideSeriesConfig;
    axisPlacement?: common.AxisPlacement;
    axisColorMode?: common.AxisColorMode;
    axisLabel?: string;
    axisWidth?: number;
    axisSoftMin?: number;
    axisSoftMax?: number;
    axisGridShow?: boolean;
    scaleDistribution?: common.ScaleDistributionConfig;
    axisCenteredZero?: boolean;
    frame?: number;
    labelValue?: common.TextDimensionConfig;
    axisBorderShow?: boolean;
}
export declare const defaultScatterSeriesConfig: () => ScatterSeriesConfig;
export interface Options {
    seriesMapping?: SeriesMapping;
    dims: XYDimensionConfig;
    legend: common.VizLegendOptions;
    tooltip: common.VizTooltipOptions;
    series: ScatterSeriesConfig[];
}
export declare const defaultOptions: () => Options;
